# !! Steps explanation
# Step 1 - Checking if 2nd and 3rd slot of the chest is empty.
# Step 2 - Checking what enchantment can be extracted from the 1st slot. Saving this information for later and proceeding with creating a book with that enchant
# Step 3 - Creating an empty enchanted book on the 3rd slot
# Step 4 - Copying the enchantments from 1st slot to 3rd slot
# Step 5 - Removing the saved enchantment from the 3rd slot
# Step 6 - Deleting the book on the 1st slot
# Step 7 - Deleting the book on the 3rd slot if it's empty for whatever reason
# Step 8 - Clearing the cache.

# !! UNIVERSAL

## Step 1
execute unless block ~ ~ ~ minecraft:chest{Items:[{Slot:1b}]} run execute unless block ~ ~ ~ minecraft:chest{Items:[{Slot:2b}]} run data modify storage ues step1 set value 1

## Step 2

# minecraft:aqua_affinity
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:aqua_affinity" run function ues:set/aqua_affinity

# minecraft:bane_of_arthropods
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:bane_of_arthropods" run function ues:set/aqua_affinity

# minecraft:binding_curse
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:binding_curse" run function ues:set/binding_curse

# minecraft:blast_protection
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:blast_protection" run function ues:set/blast_protection

# minecraft:breach
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:breach" run function ues:set/breach

# minecraft:channeling
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:channeling" run function ues:set/channeling

# minecraft:density
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:density" run function ues:set/density

# minecraft:depth_strider
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:depth_strider" run function ues:set/depth_strider

# minecraft:efficiency
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:efficiency" run function ues:set/efficiency

# minecraft:feather_falling
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:feather_falling" run function ues:set/feather_falling

# minecraft:fire_aspect
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:fire_aspect" run function ues:set/fire_aspect

# minecraft:fire_protection
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:fire_protection" run function ues:set/fire_protection

# minecraft:flame
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:flame" run function ues:set/flame

# minecraft:fortune
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:fortune" run function ues:set/fortune

# minecraft:frost_walker
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:frost_walker" run function ues:set/frost_walker

# minecraft:impaling
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:impaling" run function ues:set/impaling

# minecraft:infinity
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:infinity" run function ues:set/infinity

# minecraft:knockback
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:knockback" run function ues:set/knockback

# minecraft:looting
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:looting" run function ues:set/looting

# minecraft:loyalty
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:loyalty" run function ues:set/loyalty

# minecraft:luck_of_the_sea
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:luck_of_the_sea" run function ues:set/luck_of_the_sea

# minecraft:lure
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:lure" run function ues:set/lure

# minecraft:mending
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:mending" run function ues:set/mending

# minecraft:multishot
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:multishot" run function ues:set/multishot

# minecraft:piercing
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:piercing" run function ues:set/piercing

# minecraft:power
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:power" run function ues:set/power

# minecraft:projectile_protection
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:projectile_protection" run function ues:set/projectile_protection

# minecraft:protection
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:protection" run function ues:set/protection

# minecraft:punch
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:punch" run function ues:set/punch

# minecraft:quick_charge
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:quick_charge" run function ues:set/quick_charge

# minecraft:respiration
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:respiration" run function ues:set/respiration

# minecraft:riptide
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:riptide" run function ues:set/riptide

# minecraft:sharpness
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:sharpness" run function ues:set/sharpness

# minecraft:silk_touch
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:silk_touch" run function ues:set/silk_touch

# minecraft:smite
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:smite" run function ues:set/smite

# minecraft:soul_speed
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:soul_speed" run function ues:set/soul_speed

# minecraft:sweeping_edge
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:sweeping_edge" run function ues:set/sweeping_edge

# minecraft:swift_sneak
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:swift_sneak" run function ues:set/swift_sneak

# minecraft:thorns
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:thorns" run function ues:set/thorns

# minecraft:unbreaking
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:unbreaking" run function ues:set/unbreaking

# minecraft:vanishing_curse
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:vanishing_curse" run function ues:set/vanishing_curse

# minecraft:wind_burst
execute if data storage ues step1 run execute if data block ~ ~ ~ Items[{Slot:0b}].components."minecraft:stored_enchantments".levels."minecraft:wind_burst" run function ues:set/wind_burst

## Step 3
execute if data storage ues step2 run data modify block ~ ~ ~ Items append value {count:1,Slot:2b,id:"minecraft:enchanted_book"}
data modify storage ues step3 set value 1

## Step 4
execute if data storage ues step3 run data modify block ~ ~ ~ Items[{Slot:2b}].components set from block ~ ~ ~ Items[{Slot:0b}].components
data modify storage ues step4 set value 1

## Step 5

# minecraft:aqua_affinity
execute if data storage ues step3 run execute if data storage ues aqua_affinity run function ues:remove/aqua_affinity

# minecraft:bane_of_arthropods
execute if data storage ues step4 run execute if data storage ues bane_of_arthropods run function ues:remove/bane_of_arthropods

# minecraft:binding_curse
execute if data storage ues step4 run execute if data storage ues binding_curse run function ues:remove/binding_curse

# minecraft:blast_protection
execute if data storage ues step4 run execute if data storage ues blast_protection run function ues:remove/blast_protection

# minecraft:breach
execute if data storage ues step4 run execute if data storage ues breach run function ues:remove/breach

# minecraft:channeling
execute if data storage ues step4 run execute if data storage ues channeling run function ues:remove/channeling

# minecraft:density
execute if data storage ues step4 run execute if data storage ues density run function ues:remove/density

# minecraft:depth_strider
execute if data storage ues step4 run execute if data storage ues depth_strider run function ues:remove/depth_strider

# minecraft:efficiency
execute if data storage ues step4 run execute if data storage ues efficiency run function ues:remove/efficiency

# minecraft:feather_falling
execute if data storage ues step4 run execute if data storage ues feather_falling run function ues:remove/feather_falling

# minecraft:fire_aspect
execute if data storage ues step4 run execute if data storage ues fire_aspect run function ues:remove/fire_aspect

# minecraft:fire_protection
execute if data storage ues step4 run execute if data storage ues fire_protection run function ues:remove/fire_protection

# minecraft:flame
execute if data storage ues step4 run execute if data storage ues flame run function ues:remove/flame

# minecraft:fortune
execute if data storage ues step4 run execute if data storage ues fortune run function ues:remove/fortune

# minecraft:frost_walker
execute if data storage ues step4 run execute if data storage ues frost_walker run function ues:remove/frost_walker

# minecraft:impaling
execute if data storage ues step4 run execute if data storage ues impaling run function ues:remove/impaling

# minecraft:infinity
execute if data storage ues step4 run execute if data storage ues infinity run function ues:remove/infinity

# minecraft:knockback
execute if data storage ues step4 run execute if data storage ues knockback run function ues:remove/knockback

# minecraft:looting
execute if data storage ues step4 run execute if data storage ues looting run function ues:remove/looting

# minecraft:loyalty
execute if data storage ues step4 run execute if data storage ues loyalty run function ues:remove/loyalty

# minecraft:luck_of_the_sea
execute if data storage ues step4 run execute if data storage ues luck_of_the_sea run function ues:remove/luck_of_the_sea

# minecraft:lure
execute if data storage ues step4 run execute if data storage ues lure run function ues:remove/lure

# minecraft:mending
execute if data storage ues step4 run execute if data storage ues mending run function ues:remove/mending

# minecraft:multishot
execute if data storage ues step4 run execute if data storage ues multishot run function ues:remove/multishot

# minecraft:piercing
execute if data storage ues step4 run execute if data storage ues piercing run function ues:remove/piercing

# minecraft:power
execute if data storage ues step4 run execute if data storage ues power run function ues:remove/power

# minecraft:projectile_protection
execute if data storage ues step4 run execute if data storage ues projectile_protection run function ues:remove/projectile_protection

# minecraft:protection
execute if data storage ues step4 run execute if data storage ues protection run function ues:remove/protection

# minecraft:punch
execute if data storage ues step4 run execute if data storage ues punch run function ues:remove/punch

# minecraft:quick_charge
execute if data storage ues step4 run execute if data storage ues quick_charge run function ues:remove/quick_charge

# minecraft:respiration
execute if data storage ues step4 run execute if data storage ues respiration run function ues:remove/respiration

# minecraft:riptide
execute if data storage ues step4 run execute if data storage ues riptide run function ues:remove/riptide

# minecraft:sharpness
execute if data storage ues step4 run execute if data storage ues sharpness run function ues:remove/sharpness

# minecraft:silk_touch
execute if data storage ues step4 run execute if data storage ues silk_touch run function ues:remove/silk_touch

# minecraft:smite
execute if data storage ues step4 run execute if data storage ues smite run function ues:remove/smite

# minecraft:soul_speed
execute if data storage ues step4 run execute if data storage ues soul_speed run function ues:remove/soul_speed

# minecraft:sweeping_edge
execute if data storage ues step4 run execute if data storage ues sweeping_edge run function ues:remove/sweeping_edge

# minecraft:swift_sneak
execute if data storage ues step4 run execute if data storage ues swift_sneak run function ues:remove/swift_sneak

# minecraft:thorns
execute if data storage ues step4 run execute if data storage ues thorns run function ues:remove/thorns

# minecraft:unbreaking
execute if data storage ues step4 run execute if data storage ues unbreaking run function ues:remove/unbreaking

# minecraft:vanishing_curse
execute if data storage ues step4 run execute if data storage ues vanishing_curse run function ues:remove/vanishing_curse

# minecraft:wind_burst
execute if data storage ues step4 run execute if data storage ues wind_burst run function ues:remove/wind_burst

## Step 6
execute if data storage ues step5 run data remove block ~ ~ ~ Items[{Slot:0b}]
data modify storage ues step6 set value 1

## Step 7
execute if data storage ues step6 run execute unless block ~ ~ ~ chest{Items:[{Slot:2b,id:"minecraft:enchanted_book",count:1,components:{"minecraft:stored_enchantments":{levels:{}}}}]} run data remove block ~ ~ ~ Items[{Slot:2b}]
data modify storage ues step7 set value 1

## Step 8
execute if data storage ues step7 run function ues:clear_cache

scoreboard players set @s split_enchantments 0